	include	"ffp68343.h"
	include	"flib.h"
	include	"tios.h"
        xdef	_main
	xdef	_tibasic

;-------------------------------------------------------------
; Program made by Rafael H. Padilla V.
; dysup@mcsa.net.mx
;
; Program made with Fargo Program Editor v2.0
; Benoit SCHERRER - p.c.scherrer@wanadoo.fr
;-------------------------------------------------------------

;***************** Start of FARGO II Program ******************

_main:
				; here I get a integer from ti shell      
    pea      var_name(PC)       ; it must by from 1 to 20 only
    move.w   tios::DefTempHandle,-(a7)  ; because 20! is the most large number
    jsr      tios::FindSymEntry         ; that ffp routine can handle.
    lea      6(a7),a7
    move.w   10(a0),d0
    bne      no_error
    tios::ER_throw 1020

no_error:
    tios::DEREF d0,a0
    clr.l    d0
    clr.l    d3
    move.w   (a0),d1
    lea      1(a0,d1.w),a0
    cmp.b    #$1F,(a0)
    bne      toobig
    cmp.b    #$2,-(a0)
    bhi      toobig
    cmp.b    #1,(a0)
    beq      onedigit
    move.b   -(a0),d3
    lsl.w    #8,d3
onedigit:
    move.b   -(a0),d3
    move.w   d3,i
    cmp.w	#20,d3
    bhi	toobig
;------------- end of get parameters -------
   
	pea hello(pc)
	jsr tios::ST_showHelp
	lea 4(sp),sp

    	lea struno(pc),a0
	jsr ffp68343::ffpafp   ; pass "1" to float
        move.l d7,num
	move.l d7,fact	       ; and copy to num, fact, and uno vars
	move.l d7,uno

	clr.l d2
        move.w #1,d2		;init counter 

for_loop:	    
       move.l num,d6
       move.l fact,d7
       jsr ffp68343::ffpmul     ; fact * num -> fact
       move.l d7,fact
       move.l num,d6
       move.l uno,d7
       jsr ffp68343::ffpadd     ; num + uno -> num
       move.l d7,num
       addq #1,d2
       cmp.w i,d2
   ble for_loop

	move.l fact,d7
	jsr ffp68343::ffpfpa  ; conver fact to ascii this no work 
			      ; without tios::ST_showHelp !!!??? 	
       lea result(pc),a1
       lea    14(sp),a3

       move.w #6,d2
next:
       move.w (sp)+,(a1)+     ; in this loop a send ascii val to result var
       dbf.w d2,next

	lea (a3),sp

; ****************** here begin the data send to tishell *********
	sub.l	#2,sp            ;first I make space for stack frame
	lea	result(pc),a1
	
	cmp.b	#'+',(a1)
	beq	pos
	move.b	#128,d0
	bra	neg
pos:
	move.b	#0,d0
neg:
	cmp.l	#0,d7
	beq	d700
	cmp.l	#$007F,d7
	bhi	d7neg
	subq	#1,d7
	bra	d700
d7neg:
	addq	#1,d7
	bra	d700
d700:
	add.l	#10,a1
	move.w	(a1),d1
	sub.l	#10,a1
	and.w	#$00FF,d1
	cmp.b	#'+',d1
	beq	epos
	add.b	#48,d0
	bra	eneg
epos:
	add.b	#64,d0
eneg:
	lsl.w	#8,d0
	and.l	#$00FF,d7
	add.w	d0,d7

	move.w	d7,d6
	lsr.w	#8,d6
	move.w	d6,(sp)
	jsr	tios::push_quantum
	and.w	#$00FF,d7
	move.w	d7,(sp)
	jsr	tios::push_quantum

	clr.l	d7
	move.w	#3,d5
	addq	#2,a1
loop1:
	move.w	(a1)+,d7
	move.w	d7,d6
	lsr.w	#8,d7
	and.w	#$00FF,d6
	sub.w	#'0',d6
	sub.w	#'0',d7
	lsl.w	#4,d7
	;and.w  #$000F,d6
	add.w	d6,d7
	move.w	d7,(sp)
	jsr	tios::push_quantum

 dbf	d5,loop1
					; since the ffp routines only handle
	move.w	#$00,(sp)		; 8 digit We need fill the rest of
	jsr	tios::push_quantum	; ti-float who have 14 digits
	move.w	#$00,(sp)
	jsr	tios::push_quantum
	move.w	#$00,(sp)
	jsr	tios::push_quantum
	move.w	#$23,(sp)		; $23 it's the key for ti-float number
	jsr	tios::push_quantum

	move.b	#2,tios::main_lcd+$126E  ; I said to TIShell that here is a return value.
	add.l	#2,sp			 ; remove frame stack

	rts                              ; and finish!!!
;------------------- Fin de Programa -------
toobig:
 tios::ER_throw 40      ; argument error


;******************** Program Variables ***********************

i 		dc.l 0
fact 		dc.l 0
num		dc.l 0
uno		dc.l 0  ; sorry uno in spanish is one but I forget change this.
hello		dc.b "float routine test ",0
result 	        dc.b "1.234567890123 ",0  ;I fill this with any number but it's no necesary
struno    	dc.b "1.000",0
var_name        dc.b "x",0


 bss  
   section _tibasic

          dc.b      $E9
          dc.b      $0F,$E4             ; EndFunc
          dc.b      $00,$E8             ; :
          dc.b      $17,$E4             ; Func
          dc.b      $E5,$08             ; (x)
          dc.b      $00,$00,$40,$DC

_tibasic

;********************** End of Program ************************
	end
